"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var OAuth1HttpClient_1 = require("./OAuth1HttpClient");
var config_helper_1 = require("./config-helper");
/** @private */
var BaseAPIClient = /** @class */ (function () {
    function BaseAPIClient(xeroConfig, authState, apiConfig, oauth1Client) {
        if (authState === void 0) { authState = null; }
        if (apiConfig === void 0) { apiConfig = {}; }
        if (oauth1Client === void 0) { oauth1Client = null; }
        this.oauth1Client = oauth1Client;
        if (!xeroConfig) {
            throw new Error('Config must be passed in when creating a new instance');
        }
        if (!this.oauth1Client) {
            var oauthConfig = config_helper_1.mapConfig(xeroConfig, apiConfig);
            if (!authState) {
                authState = config_helper_1.mapState(xeroConfig);
            }
            this.oauth1Client = new OAuth1HttpClient_1.OAuth1HttpClient(oauthConfig, authState);
        }
    }
    return BaseAPIClient;
}());
exports.BaseAPIClient = BaseAPIClient;
