import { OAuth1Configuration } from '../../OAuth1HttpClient';
export declare class InMemoryOAuthLibFactoryFactory {
    inMemoryOAuthLib?: InMemoryOAuthLib;
    constructor();
    newFactory(): (config?: OAuth1Configuration) => InMemoryOAuthLib;
}
export declare class InMemoryOAuthLib {
    private config;
    [x: string]: any;
    private err;
    private returnData;
    private returnHttpResponse;
    private lastCalledUrl;
    private lastCalledMethod;
    private return_oauth_token;
    private return_oauth_secret;
    private returnAuthorisedToken;
    private returnAuthorisedSecret;
    private returnSessionHandle;
    private lastRequestedBody;
    private oauth_expires_in;
    _headers: any;
    constructor(config?: OAuth1Configuration);
    setConfig(config?: OAuth1Configuration): void;
    lastCalledThisURL(url: string): void;
    reset(): void;
    lastCalledThisMethod(verb: string): void;
    set_SwapRequestTokenforAccessToken(oauth_token: string, oauth_secret: string, oauth_expires_in: string, sessionHandle?: string): void;
    lastRequestedHadBody(expectedBody: any): void;
    lastHadThisHeader(expectedHeader: any): void;
    get(url: string, oauthToken: string, oauthSecret: string, callback: (err: any, data: string, httpResponse: any) => void): Promise<void>;
    post(url: string, oauthToken: string, oauthSecret: string, body: any, contentType: string, callback: (err: any, data: string, httpResponse: any) => void): Promise<void>;
    delete(url: string, oauthToken: string, oauthSecret: string, callback: (err: any, data: string, httpResponse: any) => void): Promise<void>;
    put(url: string, oauthToken: string, oauthSecret: string, body: string, contentType: string, callback: (err: any, data: string, httpResponse: any) => void): Promise<void>;
    setResponse(isErr: boolean, returnGetData: string, returnGetHttpResponse: any): void;
    set_getOAuthRequestToken(oauth_token: string, oauth_secret: string): void;
    getOAuthRequestToken(callback: (err: any, oauth_token: string, oauth_token_secret: string, result: any) => any): Promise<void>;
    set__performSecureRequest(oauth_token: string, oauth_secret: string, sessionHandle?: string, sessionExpires?: string): void;
    _performSecureRequest(oauth_token: string, oauth_token_secret: string, verb: string, oauthAccessTokenPath: string, extraParams: any, something: any, something2: any, callback: (err: any, response: any) => any): Promise<void>;
    getOAuthAccessToken(authedToken: string, authedSecret: string, oauthVerifier: any, callback: (err: any, oauth_token: string, oauth_token_secret: string, result: any) => any): Promise<void>;
}
